<!-- Spinner -->
<ngx-spinner [name]='"intents"' [fullScreen]="true" bdColor="#f5f5f583" size="medium" type="ball-fussion" color="#EDAE49"></ngx-spinner>

<!-- Create Intents -->
<div class="card dialog-content" style="padding: 2%">
    <!-- Title -->
    <mat-label style="display: flex; justify-content: center; margin-top: 4%; margin-bottom: 4%">
        <mat-icon style="margin-right: 9px">monitor</mat-icon>
        <h1>Create Intents</h1>
    </mat-label>

    <!-- Creation Form -->
    <form *ngIf="createIntentForm" [formGroup]="createIntentForm" novalidate (ngSubmit)="submitForm(createIntentForm.value)">
        <!-- Form First Row -->
        <div style="display: flex; justify-content: center;" class="row mb-10">
            
            <!-- Form First Column -->
            <div class="col-lg-6 col-xl-5 custom-border-right">
                <!-- Field: Workload Instace -->
                <label class="col-lg-12 col-form-label text-lg">Workload Instance ID *</label><br>
                <mat-form-field class="text-form-field" appearance="fill">
                    <input required id="workload_instance_id" name="workload_instance_id"
                        formControlName="workload_instance_id" matInput type="text" placeholder="Type Workload Instance ID"/>
                    
                    <mat-error *ngFor="let validation of incorrect_form_messages.workload_instance_id">
                        <span class="error-message" *ngIf="
                            createIntentForm.get('workload_instance_id').hasError(validation.type) &&
                            (createIntentForm.get('workload_instance_id').dirty ||
                            createIntentForm.get('workload_instance_id').touched)">
                            {{ validation.message }}
                        </span>
                    </mat-error>
                </mat-form-field><br>

                <!-- Field: Intent Type  -->
                <label class="col-lg-12 col-form-label text-lg">Intent Type *</label><br>
                <mat-form-field class="text-form-field" appearance="fill">
                    <mat-select required id="intent_type" name="intent_type"
                                formControlName="intent_type" placeholder="Select Intent Type">
                        <!-- Define your options here -->
                        <mat-option *ngFor="let option of intentTypesOptions" [value]="option">
                            {{ option }}
                        </mat-option>
                    </mat-select>
            
                    <mat-error *ngFor="let validation of incorrect_form_messages.intent_type">
                        <span class="error-message" *ngIf="
                            createIntentForm.get('intent_type').hasError(validation.type) &&
                            (createIntentForm.get('intent_type').dirty ||
                            createIntentForm.get('intent_type').touched)">
                            {{ validation.message }}
                        </span>
                    </mat-error>
                </mat-form-field><br>  
            </div>

            <!-- Form Second Column -->
            <div class="col-lg-6 col-xl-5">
                <!-- Field: Start Time -->
                <label class="col-lg-12 col-form-label text-lg">Start Date-time</label><br>
                <mat-form-field class="datetime-form-field" appearance="fill">
                    <input matInput readonly [ngxMatDatetimePicker]="start_picker" placeholder="Choose start datetime" formControlName="start_time">
                    <mat-datepicker-toggle matSuffix [for]="$any(start_picker)"></mat-datepicker-toggle>
                    <ngx-mat-datetime-picker #start_picker [color]="'warn'"> </ngx-mat-datetime-picker>
                </mat-form-field><br>

                <!-- Field: End Time -->
                <label class="col-lg-12 col-form-label text-lg">End Date-time</label><br>
                <mat-form-field class="datetime-form-field" appearance="fill">
                    <input matInput readonly [ngxMatDatetimePicker]="end_picker" placeholder="Choose end datetime" formControlName="end_time">
                    <mat-datepicker-toggle matSuffix [for]="$any(end_picker)"></mat-datepicker-toggle>
                    <ngx-mat-datetime-picker #end_picker [color]="'warn'"> </ngx-mat-datetime-picker>
                </mat-form-field><br>
            

            </div>

        </div>

        <!-- Target Labels -->
        <div style="display: flex; justify-content: center;" class="row mb-10">
            <div class="col-lg-12 col-xl-10">
                <div class="row">
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">Target Name</label><br>
                    </div>
                    <div class="col-lg-2">
                        <label class="col-lg-12 col-form-label text-lg">Target Condition</label><br>
                    </div>
                    <div class="col-lg-5">
                        <label class="col-lg-12 col-form-label text-lg">Target Value</label><br>
                    </div>
                </div>
            </div>
        </div>

        <!-- Targets -->
        <div style="display: flex; justify-content: center;" class="row mb-10">
            <div formArrayName="targets" class="col-lg-12 col-xl-10">
                <div *ngFor="let control of targets.controls; let iarr = index">
                    <div [formGroupName]="iarr">
                        <div class="row">
                            <div class="col-lg-4">
                                <mat-form-field class="text-form-field-targ" appearance="fill">
                                    <input name="target_name"
                                        formControlName="target_name" matInput type="text" placeholder="Type Workload Instance ID"/>    
                                </mat-form-field><br>
                            </div>
                            <div class="col-lg-2">
                                <mat-form-field class="text-form-field-targ" appearance="fill">
                                    <mat-select name="target_condition"
                                                formControlName="target_condition" placeholder="Select Condition">
                                        <mat-option *ngFor="let option of target_condition_Options" [value]="option">
                                            {{ option }}
                                        </mat-option>
                                    </mat-select>
                                </mat-form-field><br>
                            </div>
                            <div class="col-lg-5">
                                <mat-form-field class="text-form-field-targ" appearance="fill">
                                    <input name="target_value"
                                        formControlName="target_value" matInput type="text" placeholder="Type Workload Instance ID"/>
                                </mat-form-field><br>
                            </div>
                        </div>
                    </div>
                    <mat-error *ngFor="let validation of incorrect_form_messages.targets">
                        <span class="error-message" *ngIf=
                            "control.hasError('incompleteTargetValidator') && (control.dirty)">
                            {{ validation.message }}
                        </span>
                    </mat-error>
                </div>
            </div>
        </div>

        <!-- Add Target Button -->
        <div style="display: flex; justify-content: center;" class="row mb-10">
            <div class="col-lg-12 col-xl-10" style="margin-bottom: 20px;">                    
                <button type="button" mat-raised-button id="addFormFiel_button" class="btn-2"
                    (click)="addFormField()">
                    <span class="indicator-label">
                    <a> Add Field </a>
                    </span>
                </button>
            </div>
        </div> 
    </form>

    <div class="card-footer" style="display: flex; justify-content: end; background-color: white;">
        <div class="row">
            <div class="col-lg-22">
                <!-- Submit button -->
                <button mat-raised-button id="submit_button" class="btn-2"
                    type="submit" (click)="submitForm(createIntentForm.value)">
                    <span class="indicator-label">
                    <a> Create </a>
                    </span>
                </button>

                <!-- Reset button -->                    
                <button (click)="resetForm()" id="reset_button" mat-raised-button> 
                    Reset
                </button>

            </div>
        </div>
    </div>

</div>
